// Generated by CoffeeScript 1.6.3
/*
# #MongoSkin Initializer
# *__Author__: Panjie SW <panjie@panjiesw.com>*
# *__Project__: actionHero-mongoskin*
#
# Provides MongoDB connection initialization via MongoSkin and shortcut functions.
# You can easily add others or modify this as needed by overriding the initializer.
# *********************************************
*/

var mongo, mongodb;

mongodb = require('mongoskin');

/*
# Expose some of mongo driver object to `api.mongo` so we can use them
# again later without requiring the driver.
*/


mongo = {
  ObjectID: mongodb.ObjectID,
  ObjectId: mongodb.ObjectID,
  Timestamp: mongodb.Timestamp,
  router: mongodb.router,
  Cursor: mongodb.Cursor,
  GridStore: mongodb.GridStore,
  dbSeed: function(next) {
    return next();
  }
};

mongo._start = function(api, next) {
  var config;
  config = api.configData.mongo;
  if (!config) {
    config = {
      seed: true,
      host: "localhost",
      port: 27017,
      db: "test",
      user: "",
      pass: ""
    };
  }
  api.mongo.db = mongodb.db("" + config.user + ":" + config.pass + "@" + config.host + ":" + config.port + "/" + config.db, {
    w: 1
  });
  return api.mongo.db.open(function(err, db) {
    if (err) {
      api.log("Error opening MongoDB Connection: " + err.message, 'error');
      api.log(err.stack, 'error');
      process.exit(1);
    }
    api.mongo.toObjectId = api.mongo.toId = api.mongo.db.toId;
    api.log("MongoDB connection opened", 'debug');
    if (config.seed) {
      api.log("Seed set to true, dropping database first");
      return api.mongo.db.dropDatabase(function(err, done) {
        if (err) {
          api.log("Error dropping database", 'warning');
          return api.log(err.stack, 'error');
        } else {
          return api.mongo.dbSeed(next);
        }
      });
    } else {
      return next();
    }
  });
};

mongo._teardown = function(api, next) {
  return api.mongo.db.close(function(err, db) {
    api.log("MongoDB connection closed", 'debug');
    return next();
  });
};

exports.mongo = mongo;

exports.mongoinit = function(api, next) {
  api.mongo = mongo;
  return next();
};
